//
//  Controller.m
//  Calc
//
//  Created by KOYAMA Yoshiaki on 05/05/31.
//  Copyright 2005 KOYAMA Yoshiaki. All rights reserved.
//

#import "Controller.h"
#import "Lexical.h"
#import "Syntax.h"
#import "ErrorMessage.h"

@implementation Controller

- (id)init {
    self = [super init];

//	[_lex setText:@"(100 * 100 + -2*10+		(10*10))"];

    return self;
}

- (void)dealloc {

	[_lex release];
	[_syntax release];
	[_errorMessage release];

    [super dealloc];
}

- (BOOL)windowShouldClose:(id)sender{
	[NSApp terminate:self];
	return YES;
}

- (IBAction)analyze:(id)sender {
	NSString *str;
	double result;

	[_syntax release];
	[_lex release];
	[_errorMessage release];

	str = [[NSString alloc] initWithString:[_text string]];
	_errorMessage = [[ErrorMessage alloc] init];

	_lex = [[Lexical alloc] init];
	[_lex setText:str];
	[_lex setErrorMessage:_errorMessage];
	[str release];

	_syntax = [[Syntax alloc] init];
	[_syntax setLex:_lex];
	[_syntax setErrorMessage:_errorMessage];

	result = [_syntax analyze];
//	[_lex analyze];

	[_errorText setString:@""];

	if ([_errorMessage errorFlag] == YES) {
//NSLog(@"Error");
		[_errorText setString:[_errorMessage errorMessage]];
	} else {
		[_result setDoubleValue:result];
	}

}

@end
