//
//  ErrorMessage.m
//  Calc
//
//  Created by KOYAMA Yoshiaki on 05/06/05.
//  Copyright 2005 KOYAMA Yoshiaki. All rights reserved.
//

#import "ErrorMessage.h"


@implementation ErrorMessage

- (id)init {
    self = [super init];
	_errorFlag = NO;

	_array = [[NSMutableArray array] retain];
	[self initDictionary];
    return self;
}

- (void)initDictionary {
	NSString *message;

	_dictionary = [NSMutableDictionary dictionary];
	[_dictionary retain];

	message = NSLocalizedString(@"M00",@"ERROR 00");
	[_dictionary setObject:message forKey:@"M00"];

	message = NSLocalizedString(@"M01",@"ERROR 01");
	[_dictionary setObject:message forKey:@"M01"];

	message = NSLocalizedString(@"M02",@"ERROR 02");
	[_dictionary setObject:message forKey:@"M02"];

	message = NSLocalizedString(@"M03",@"ERROR 03");
	[_dictionary setObject:message forKey:@"M03"];

	message = NSLocalizedString(@"M04",@"ERROR 04");
	[_dictionary setObject:message forKey:@"M04"];
}

- (void)addNumber:(int)num {
	[_array addObject:[NSNumber numberWithInt:num]];
}

- (NSMutableString *)errorMessage {
	NSMutableString *message;
	NSString *num;
	NSNumber *number;
	NSString *dict;
	int i;

	message = [NSMutableString string];

	for (i=0; i<[_array count]; i++) {
		number = [_array objectAtIndex:i];
		num = [NSString stringWithFormat:@"M%02d", [number intValue]];
		dict = [_dictionary objectForKey:num];
		[message appendString:dict];
	}

	return message;
}

- (void)setErrorFlag:(BOOL)flag {
	_errorFlag = flag;
}

- (BOOL)errorFlag {
	return _errorFlag;
}

- (void)dealloc {
	[_array release];
	[_dictionary release];
    [super dealloc];
}

@end
